#include <stdio.h>
#include <math.h>

/* Constantes du jeu */
#define LIM_INF 0
#define LIM_SUP 1000
#define MAX_TENT 10

int verif_saisie (int chiffre,int min, int max){
  if ( ( chiffre > max ) || ( chiffre <min ) )
    return(0);
  else
    return(1);
}

int donne_ecart(int choix, int but){
  return(choix - but);
}

void blancs(void){
  int i;
  for (i=1;i<3;i++){
    printf("\n");
  }
}

/* Programme principal */
int main(){
  int nb = (int)NULL;
  int le_chiffre = (int)NULL;
  int choix = (int)NULL;
  int ecart = (int)NULL;
  int ok = (int)NULL;
  int encore = (int)NULL;
  int min = LIM_INF ;
  int max = LIM_SUP ;
	
  blancs();
  printf("Bonjour et bienvenue au jeu \"En plein dans le mil\".\n");
  printf("Le but du jeu est de trouver un chiffre entre %d et %d.\n",LIM_INF,LIM_SUP);
  printf("Pour cela vous avez %d tentatives.\n",MAX_TENT);
  printf("Bonne chance !!!\n");
  blancs();
	
  /* Cration d'une liste de chiffres pseudo-alatoires */
  srand(100);
  do{
    le_chiffre = rand()-1;
    if ( le_chiffre > 1000 ){
      do{
	le_chiffre = le_chiffre / 2; 
      } while ( le_chiffre > 1000 );
    }
    nb = 1;
    do{
      do{
	printf("Veuillez saisir un chiffre entre %d et %d.\n",min,max);
	scanf("%d",&choix);
	ok =  verif_saisie(choix,LIM_INF,LIM_SUP);
      } while ( ok == 0 );
			
      ecart = donne_ecart(choix,le_chiffre);
      if ( ecart != 0  ){
	printf("VOUS ETES ");
	if ( ecart < 0 ){
	  printf(" EN DESSOUS.\n");
	  if ( choix > min )
	    min = choix;
	}else{				
	  printf(" AU DESSUS.\n");
	  if ( choix < max )
	    max = choix;	
	}
	nb = nb + 1;
			    
	blancs();	
      }			
    }while ( (nb < MAX_TENT ) && ( ecart != 0 ) );
		
    if ( ecart == 0 )
      printf("BRAVO vous avez trouv le chiffre : %d en %d esssais.\n",le_chiffre,nb);
    else
      printf("DOMMAGE !!! Le chiffre  trouver tait %d.\n",le_chiffre);
			
    printf("ON R'MET  !!?? [ 0 -> NON ; 1 -> OUI ]\n");
    scanf("%d",&encore);
    blancs();
    min = LIM_INF ;
    max = LIM_SUP ;
  } while ( encore == 1);
}
